function [posSIFT negSIFT] = get_features(back, labels)
    % Return SIFT located inside (posSIFT) and outside the region covered
    % by each label.
    scale = 800 / size(back, 2);
    back = imresize(back, scale);
    [h w] = size(back);
    labels = imresize(labels, [h w], 'nearest');        

    [feat featpos] = SIFT_features(back, 8);
    X = featpos(:, 1);
    Y = featpos(:, 2);
    
    nlabels = size(labels, 3);
    posSIFT = cell(1, nlabels);
    negSIFT = cell(1, nlabels);
    for i = 1 : nlabels
        l = logical(labels(:, :, i));        
        isPos = l((X - 1) * h + Y);
    
        if ~isempty(find(isPos, 1))            
            posSIFT{i} = mean(feat(isPos, :), 1);
        end
        if ~isempty(find(~isPos, 1))
            negSIFT{i} = mean(feat(~isPos, :), 1);
        end
    end
end