function make_splits(params)
    vids = ssem_load_videos(params);
    nvids = length(vids);

    file = fullfile(params.root, sprintf(params.split_file, params.n_splits, nvids));
    if exist(file, 'file')
        return;
    end
    
    N = params.n_splits;                
    
    nlabels = zeros(nvids, length(params.annots.labels));
    vidIDs  = cell(nvids, 1);
    vidID = 0;
    for i = 1 : nvids
        v = ssem_load_subvideos(params, vids(i));
        annot = ssem_load_annots(params, v);
        for j = 1 : length(v)
            vidID = vidID + 1;
            vidIDs{i} = [vidIDs{i} vidID];    
            labels = ssem_unpack_annot(annot{j});            
            npix = length(find(sum(labels, 3)));
            for k = 1 : length(params.annots.labels)
                nlabels(i, k) = nlabels(i, k) + length(find(labels(:,:,k))) / npix;               
            end           
        end        
    end    
            
    splits      = cell(N, 1);
    nvidsSplits = zeros(N, 1); 
    freqLabels  = zeros(N, length(params.annots.labels));
    I = 1 : nvids;
    while ~isempty(I)
        [~, isplit] = min(nvidsSplits);
        nl = repmat(freqLabels(isplit, :), length(I), 1) + nlabels(I, :);
        nl = nl ./ repmat(sum(nl, 2), 1, size(nl, 2));
        H = - nl .* log(nl); % entropy
        H(isnan(H)) = 0;        
        H = sum(H, 2);        
        [~, tmpivid] = max(H);  % max entropy
        ivid = I(tmpivid);
        I(tmpivid) = [];
        nvidsSplits(isplit) = nvidsSplits(isplit) + length(vidIDs{ivid});
        freqLabels(isplit, :) = freqLabels(isplit, :) + nlabels(ivid, :);
        v = ssem_load_subvideos(params, vids(ivid));
        for j = 1 : length(v)
            splits{isplit} = [splits{isplit} v(j)];              
        end
    end
    
    for i = 1 : N
        freqLabels(i, :) = freqLabels(i, :) / nvidsSplits(i);
    end       
    
    save(file, 'splits', 'freqLabels');
end
