#include <string.h>
#include "mex.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) 
{ 	
  mwSize *dim;
    
  unsigned short *med;
  unsigned char *img;
 
  unsigned int i, j, k, a;
  int count;
  unsigned short m;
  
  if (nrhs != 1)
    mexErrMsgTxt("Expecting 1 input: median counter");  
  if (nlhs != 1)
    mexErrMsgTxt("Expecting 1 output.");  
  if (mxGetClassID(prhs[0]) != mxUINT16_CLASS || mxGetNumberOfDimensions(prhs[0]) != 4)
    mexErrMsgTxt("First input should be a 4-dimensional matrix of type UINT16 containing median counter.");  
          
  dim = mxGetDimensions(prhs[0]);
  if(dim[0] != 256)
  		mexErrMsgTxt("The first dimension of first input should be 255.");
  if(dim[3] != 3)
  		mexErrMsgTxt("The fourth dimension of first input should be 3.");
        
  med = (unsigned short*)mxGetPr(prhs[0]);  
  plhs[0] = mxCreateNumericArray(3, dim + 1, mxUINT8_CLASS, mxREAL);
  img = (unsigned char*)mxGetPr(plhs[0]);

	for(k = 0; k < 3; k++)
	  for(j = 0; j < dim[2]; j++)
		  for(i = 0; i < dim[1]; i++)
	    {
	      a = i + dim[1] * (j + dim[2] * k);
	      count = 0;
 		    for(m = 0; m < 256; m++)
 		    	count += med[m + 256 * a]; 		    
 		    if(count != 0)
 		    {
 		      count = count / 2;
			  	for(m = 0; m < 256; m++)
			  	{
	 		    	count -= med[m + 256 * a];
	 		    	if(count < 0)
	 		    		break;
			  	}
			  	img[a] = m;
			  }
	    }  
}  
